/*
 *  gcube
 *  Copyright (c) 2004 monk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 *      
 *         
 */

#include "hw.h"


void install_exception_handlers (void)
{
	__u32 reset_handler[] =
	{
		0x38600000,		// li  r3, 0
		0x3d20cc00,		// lis r9, 0xcc00
		0x90693024,		// stw r3, 0x3024 (r9) -> will cause reset
	};
	__u32 decrementer_handler[] =
	{
		// hack to get testdemo4 working
		0x3bff0001,		// addi r31, r31, 1
		0x4c000064,		// rfi
	};
	__u32 empty_handler[] =
	{
		0x3d20cc00,		// lis r9, 0xcc00
		0x61293000,		// ori r9, r9, 0x3000
		0x80090000,		// lwz r0, 0 (r9)
		0x4c000064,		// rfi
	};
	int i;


	for (i = 0; i < sizeof (reset_handler) / 4; i++)
	{
		MEM_WWORD (EXCEPTION_SYSTEM_RESET + i*4, reset_handler[i]);
		// dol reload
		MEM_WWORD (0x80001800 + i*4, reset_handler[i]);
	}

	for (i = 0; i < sizeof (decrementer_handler) / 4; i++)
		MEM_WWORD (EXCEPTION_DECREMENTER + i*4, decrementer_handler[i]);

	for (i = 0; i < sizeof (empty_handler) / 4; i++)
	{
		MEM_WWORD (EXCEPTION_SYSTEM_CALL + i*4, empty_handler[i]);
		MEM_WWORD (EXCEPTION_EXTERNAL + i*4, empty_handler[i]);
	}
}


// this should be called after loading file
void hw_init (void)
{
	dsp_init ();
	cp_init ();
	di_init ();
	exi_init ();
	gx_init ();
	mi_init ();
	pe_init ();
	pi_init ();
	si_init ();
	vi_init ();


	MEM_WWORD (MEM_CONSOLE_TYPE, CONSOLE_TYPE_LATEST_PB);

	MEM_WWORD (MEM_HEAP_BOTTOM, ARENA_LO);
	MEM_WWORD (MEM_HEAP_TOP, ARENA_HI);
	
	MEM_WWORD (MEM_MEM_SIZE, MEM_SIZE);
	MEM_WWORD (MEM_SIM_MEM_SIZE, MEM_SIZE);

	MEM_WWORD (MEM_BUS_CLOCK_SPEED, BUS_CLOCK_SPEED);
	MEM_WWORD (MEM_CPU_CLOCK_SPEED, CPU_CLOCK_SPEED);

	MEM_WWORD (MEM_MAGIC, MEM_MAGIC_NORMAL);

	install_exception_handlers ();
}
