/*
 *  gcube
 *  Copyright (c) 2004 monk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *  CP - commad processor (0xcc000000)
 *      
 *         
 */

#include "hw_cp.h"


__u8 rcp[RCP_SIZE] = {0};



__u16 cp_r16_direct (__u32 addr)
{
	DEBUG (EVENT_LOG, "..cp: read  [%.4x] (%.4x)", addr & 0xffff, RCP16 (addr));
	return RCP16 (addr);
}


void cp_w16_direct (__u32 addr, __u16 data)
{
	DEBUG (EVENT_LOG, "..cp: write [%.4x] (%.4x) = %.4x", addr & 0xffff, RCP16 (addr), data);
	RCP16 (addr) = data;
}


void cp_w16_clear (__u32 addr, __u16 data)
{
	DEBUG (EVENT_LOG, "..cp: clear FIFO UF %d | clear FIFO OF %d", (data & 2)>0, data & 1);
	RCP16 (addr) = data;
}


void cp_init (void)
{
	memset (rcp, 0, sizeof (rcp));
	
	mem_hww_hook (16, CP_CLEAR, cp_w16_clear);
	mem_hww_hook (16, CP_TOKEN, cp_w16_direct);
	mem_hww_hook (16, CP_BB_LEFT, cp_w16_direct);
	mem_hww_hook (16, CP_BB_RIGHT, cp_w16_direct);
	mem_hww_hook (16, CP_BB_TOP, cp_w16_direct);
	mem_hww_hook (16, CP_BB_BOTTOM, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_BASE_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_BASE_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_END_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_END_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_HWMARK_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_HWMARK_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_LWMARK_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_LWMARK_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_RW_DIST_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_RW_DIST_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_WPOINTER_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_WPOINTER_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_RPOINTER_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_RPOINTER_HI, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_BP_LO, cp_w16_direct);
	mem_hww_hook (16, CP_FIFO_BP_HI, cp_w16_direct);
}
