/*
 *  gcube
 *  Copyright (c) 2004 monk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *  DI - dvd interface (0xcc006000)
 *      
 *         
 */

#include "hw_di.h"


__u8 rdi[RDI_SIZE] = {0};



__u32 di_r32_direct (__u32 addr)
{
	DEBUG (EVENT_LOG, "..di: read  [%.4x] (%.8x)", addr & 0xffff, RDI32 (addr));
	return RDI32 (addr);
}


void di_w32_direct (__u32 addr, __u32 data)
{
	DEBUG (EVENT_LOG, "..di: write [%.4x] (%.8x) = %.8x", addr & 0xffff, RDI32 (addr), data);
	RDI32 (addr) = data;
}


void di_init (void)
{
	memset (rdi, 0, sizeof (rdi));
	
	// dicfg
	mem_hwr_hook (32, 0x6024, di_r32_direct);
	mem_hww_hook (32, 0x6024, di_w32_direct);
}
